----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:32:51 07/17/2006 
-- Design Name: 
-- Module Name:    SSN_if - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity SSN_if is
    generic (step : integer := 1);
    Port ( clk : in  STD_LOGIC;
           en_SSN : in  STD_LOGIC;
           SSN : inout  STD_LOGIC;
           SSN_ROM : out  STD_LOGIC_VECTOR (63 downto 0);
           SSN_CRC : out  STD_LOGIC_VECTOR (7 downto 0);
           SSN_valid : out  STD_LOGIC;
           SSN_done : out  STD_LOGIC
			  );
end SSN_if;

architecture Behavioral of SSN_if is
signal div : std_logic_vector(21 downto 0) := (others => '0');
signal SSN_low : std_logic;
signal sample_time : std_logic;
signal sr : std_logic_vector(63 downto 0);
signal crc_inv : std_logic_vector(7 downto 0);
signal crc : std_logic_vector(7 downto 0);
signal done : std_logic;
attribute INIT : string;
attribute INIT of done : signal is "0";
attribute INIT of div : signal is "0";
begin
SSN_done <= done;
SSN <= '0' when SSN_low = '1' else 'Z';
SSN_CRC <= crc_inv;
g: for i in crc'range generate
  crc_inv(i) <= crc(7-i);
end generate;
process(clk)
begin
  if(clk'event and clk = '1')then
    if(done = '0')then
	   SSN_ROM <= (others => '0');
	 else	
      SSN_ROM <= sr;
	 end if;
    if(en_SSN = '0')then
	   div <= (others => '0');
    elsif(done = '1')then
	   div <= (others => '1');
	 else	
      div <= div + step;
	 end if;
	 if(div(17 downto 15) = "000" or 
	    (div(17 downto 14) = x"3" and div(12) = '1' and div(10 downto 8) /= "111") or
	    (div(17 downto 16) /= "11" and div(17 downto 14) /= x"2" and div(10 downto 7) = x"0"))then
	   SSN_low <= '1';
	 else
	   SSN_low <= '0';
	 end if;
	 if(div(17) /= div(16) and div(10 downto 0) = "00100000000")then
	   sample_time <= '1';
	 else
	   sample_time <= '0';
	 end if;
	 if(sample_time = '1')then
	   sr <= SSN & sr(63 downto 1);
	 end if;
	 if(div(17 downto 15) = "001")then
	   crc <= x"00";
	 elsif(sample_time = '1' and div(16 downto 14) /= "100")then
	   crc(7 downto 5) <= crc(6 downto 5) & (sr(56) xor crc(7) xor crc(4));
	   crc(4) <= sr(56) xor crc(7) xor crc(3);
	   crc(3 downto 0) <= crc(2 downto 0) & (crc(7) xor sr(56));
	 end if;
	 if(div(21) = '1' or (div(17 downto 16) = "11" and crc = sr(63 downto 56)))then
	   done <= '1';
	 else
	   done <= '0';
	 end if;
	 if(crc_inv = sr(63 downto 56))then
	   SSN_valid <= '1';
	 else	
	   SSN_valid <= '0';
	 end if;
  end if;
end process;

end Behavioral;

