library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
entity crc16D8 is
    Port ( clk : in std_logic;
           init_crc : in std_logic;
           we_crc : in std_logic;
           d : in std_logic_vector(7 downto 0);
           crc : out std_logic_vector(15 downto 0));
end crc16D8;

architecture my_arch of crc16D8 is
signal c : std_logic_vector(15 downto 0);
begin
crc <= c;
process(clk)
begin
  if(clk'event and clk = '1')then
    if(init_crc = '1')then
      c <= (others => '1');
	 elsif(we_crc = '1')then
      c(0)  <= d(7)  xor d(6)  xor d(5)  xor d(4)  xor d(3)  xor d(2)  xor
               d(1)  xor d(0)  xor c(15) xor c(14) xor c(13) xor c(12) xor
               c(11) xor c(10) xor c(9)  xor c(8);
      c(1)  <= d(7)  xor d(6)  xor d(5)  xor d(4)  xor d(3)  xor d(2)  xor
               d(1)  xor c(15) xor c(14) xor c(13) xor c(12) xor c(11) xor
               c(10) xor c(9);
      c(2)  <= d(1)  xor d(0)  xor c(9)  xor c(8);
      c(3)  <= d(2)  xor d(1)  xor c(10) xor c(9);
      c(4)  <= d(3)  xor d(2)  xor c(11) xor c(10);
      c(5)  <= d(4)  xor d(3)  xor c(12) xor c(11);
      c(6)  <= d(5)  xor d(4)  xor c(13) xor c(12);
      c(7)  <= d(6)  xor d(5)  xor c(14) xor c(13);
      c(8)  <= d(7)  xor d(6)  xor c(15) xor c(14) xor c(0);
      c(9)  <= d(7)  xor c(15) xor c(1);
      c(10) <= c(2);
      c(11) <= c(3);
      c(12) <= c(4);
      c(13) <= c(5);
      c(14) <= c(6);
      c(15) <= d(7)  xor d(6)  xor d(5)  xor d(4)  xor d(3)  xor d(2)  xor
               d(1)  xor d(0)  xor c(15) xor c(14) xor c(13) xor c(12) xor
               c(11) xor c(10) xor c(9)  xor c(8)  xor c(7);
	 end if;
  end if;
end process;
end my_arch;
