----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:24:16 12/16/2006 
-- Design Name: 
-- Module Name:    monitor - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- mon_in(7 downto 0) use TKO_clk
-- mon_in(31 downto 8) use clk
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use mylib.atm_pack.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity monitor is
    Port ( clk : in  STD_LOGIC;
           clk4x : in  STD_LOGIC;
           TKO_clk : in  STD_LOGIC;
           reset : in  STD_LOGIC_VECTOR (15 downto 0);
           latch : in  STD_LOGIC_VECTOR (15 downto 0);
           addr : in  STD_LOGIC_VECTOR (15 downto 0);
           we : in  STD_LOGIC;
           re : in  STD_LOGIC;
           mon_in : in  STD_LOGIC_VECTOR (15 downto 0);
           ack : out  STD_LOGIC;
           dout : out  STD_LOGIC_VECTOR (7 downto 0));
end monitor;

architecture Behavioral of monitor is
component adder
  port (
    a: in std_logic_vector (31 downto 0);
    b: in std_logic_vector (31 downto 0);
    ci: in std_logic;
    s: out std_logic_vector (31 downto 0);
    co: out std_logic
  );
end component;
signal clk_toggle : std_logic := '0';
signal clk_toggle_q : std_logic := '0';
signal new_addr : std_logic;
signal clk2x : std_logic;
signal phase : std_logic_vector(3 downto 0);
signal rst_ps : std_logic_vector(11 downto 0);
signal last_addr : std_logic_vector(7 downto 1);
signal ps0 : std_logic_vector(4 downto 0) := (others => '0');
signal ps1 : std_logic_vector(4 downto 0) := (others => '0');
signal ps2 : std_logic_vector(4 downto 0) := (others => '0');
signal ps3 : std_logic_vector(4 downto 0) := (others => '0');
signal ps4 : std_logic_vector(4 downto 0) := (others => '0');
signal ps5 : std_logic_vector(4 downto 0) := (others => '0');
signal ps6 : std_logic_vector(4 downto 0) := (others => '0');
signal ps7 : std_logic_vector(4 downto 0) := (others => '0');
signal ps8 : std_logic_vector(3 downto 0) := (others => '0');
signal ps9 : std_logic_vector(3 downto 0) := (others => '0');
signal psa : std_logic_vector(3 downto 0) := (others => '0');
signal psb : std_logic_vector(3 downto 0) := (others => '0');
signal psc : std_logic_vector(3 downto 0) := (others => '0');
signal psd : std_logic_vector(3 downto 0) := (others => '0');
signal pse : std_logic_vector(3 downto 0) := (others => '0');
signal psf : std_logic_vector(3 downto 0) := (others => '0');
signal scan_TKO : std_logic_vector(2 downto 0) := (others => '0');
signal scan3_sync : std_logic_vector(1 downto 0) := (others => '0');
signal TKO_mux : std_logic_vector(4 downto 0);
signal TKO_buf : std_logic_vector(4 downto 0);
signal TKO_scan : std_logic;
signal TKO_we : std_logic;
signal scan : std_logic_vector(4 downto 0) := (others => '0');
signal mux : std_logic_vector(5 downto 0);
signal carry : std_logic;
signal co : std_logic;
signal inc : std_logic_vector(31 downto 0);
signal sum : std_logic_vector(31 downto 0);
signal cntr_din : std_logic_vector(31 downto 0);
signal cntr_dout : std_logic_vector(31 downto 0);
signal cntr_dout_q : std_logic_vector(31 downto 0);
signal cntr_wa : std_logic_vector(8 downto 0);
signal cntr_ra : std_logic_vector(8 downto 0);
signal cntr_ra_q : std_logic_vector(4 downto 0);
signal cntr_ra_q2 : std_logic_vector(4 downto 0);
signal cntr_we : std_logic;
signal buf_ra : std_logic_vector(10 downto 0);
signal buf_wa : std_logic_vector(8 downto 0);
signal buf_dout : std_logic_vector(7 downto 0);
signal update : std_logic_vector(15 downto 0);
signal rst_update : std_logic_vector(15 downto 0);
signal update_mux : std_logic;
signal reset_mux : std_logic;
signal rst_cntr : std_logic;
signal latch_we : std_logic;
signal latch_dout : std_logic_vector(31 downto 0);
signal latch_ra : std_logic_vector(8 downto 0);
signal start : std_logic;
signal buf_we : std_logic;
attribute INIT : string;
attribute INIT of new_addr : signal is "S";
begin
process(clk)
begin
  if(clk'event and clk = '1')then
    clk_toggle <= not clk_toggle;
	 if(we = '1')then
	   new_addr <= '1';
	 elsif(re = '1')then
	   if(addr(15 downto 8) /= mon_addr(15 downto 8))then
		  new_addr <= '1';
		else
		  new_addr <= '0';
		end if;
	 end if;
	 if(re = '1' and addr(15 downto 8) = mon_addr(15 downto 8))then
	   last_addr <= addr(7 downto 1);
		if(addr(7 downto 3) /= last_addr(7 downto 3) or
			addr(2 downto 1) < last_addr(2 downto 1) or new_addr = '1')then
		  start <= '1';
      end if;		  
	 else
	   start <= '0';
	 end if;
	 if(re = '1' and addr(15 downto 8) = mon_addr(15 downto 8))then
	   ack <= '1';
	 else
	   ack <= '0';
	 end if;
  end if;  
end process;
process(clk4x)
begin
  if(clk4x'event and clk4x = '1')then
    clk_toggle_q <= clk_toggle;
	 phase(1) <= clk_toggle xor clk_toggle_q;
	 phase(3 downto 2) <= phase(2 downto 1);
	 phase(0) <= phase(3);
	 clk2x <= phase(1) or phase(3);
  end if;  
end process;
process(TKO_clk,reset)
begin
  if(reset(0) = '1')then
	 ps0 <= "00000";
  elsif(TKO_clk'event and TKO_clk = '1')then
	 if(rst_ps(0) = '1')then
		ps0 <= "0000" & mon_in(0);
	 elsif(mon_in(0) = '1')then
		ps0 <= ps0 + 1;
	 end if;
  end if;  
end process;
process(TKO_clk,reset)
begin
  if(reset(1) = '1')then
	 ps1 <= "00000";
  elsif(TKO_clk'event and TKO_clk = '1')then
	 if(rst_ps(1) = '1')then
		ps1 <= "0000" & mon_in(1);
	 elsif(mon_in(1) = '1')then
		ps1 <= ps1 + 1;
	 end if;
  end if;  
end process;
process(TKO_clk,reset)
begin
  if(reset(2) = '1')then
	 ps2 <= "00000";
  elsif(TKO_clk'event and TKO_clk = '1')then
	 if(rst_ps(2) = '1')then
		ps2 <= "0000" & mon_in(2);
	 elsif(mon_in(2) = '1')then
		ps2 <= ps2 + 1;
	 end if;
  end if;  
end process;
process(TKO_clk,reset)
begin
  if(reset(3) = '1')then
	 ps3 <= "00000";
  elsif(TKO_clk'event and TKO_clk = '1')then
	 if(rst_ps(3) = '1')then
		ps3 <= "0000" & mon_in(3);
	 elsif(mon_in(3) = '1')then
		ps3 <= ps3 + 1;
	 end if;
  end if;  
end process;
process(TKO_clk,reset)
begin
  if(reset(4) = '1')then
	 ps4 <= "00000";
  elsif(TKO_clk'event and TKO_clk = '1')then
	 if(rst_ps(4) = '1')then
		ps4 <= "0000" & mon_in(4);
	 elsif(mon_in(4) = '1')then
		ps4 <= ps4 + 1;
	 end if;
  end if;  
end process;
process(TKO_clk,reset)
begin
  if(reset(5) = '1')then
	 ps5 <= "00000";
  elsif(TKO_clk'event and TKO_clk = '1')then
	 if(rst_ps(5) = '1')then
		ps5 <= "0000" & mon_in(5);
	 elsif(mon_in(5) = '1')then
		ps5 <= ps5 + 1;
	 end if;
  end if;  
end process;
process(TKO_clk,reset)
begin
  if(reset(6) = '1')then
	 ps6 <= "00000";
  elsif(TKO_clk'event and TKO_clk = '1')then
	 if(rst_ps(6) = '1')then
		ps6 <= "0000" & mon_in(6);
	 elsif(mon_in(6) = '1')then
		ps6 <= ps6 + 1;
	 end if;
  end if;  
end process;
process(TKO_clk,reset)
begin
  if(reset(7) = '1')then
	 ps7 <= "00000";
  elsif(TKO_clk'event and TKO_clk = '1')then
	 if(rst_ps(7) = '1')then
		ps7 <= "0000" & mon_in(7);
	 elsif(mon_in(7) = '1')then
		ps7 <= ps7 + 1;
	 end if;
  end if;  
end process;
process(TKO_clk)
begin
  if(TKO_clk'event and TKO_clk = '1')then
	 scan3_sync <= scan3_sync(0) & scan(3);
	 if(scan3_sync = "01")then
	   TKO_scan <= '1';
	 elsif(rst_ps(0) = '1')then
	   TKO_scan <= '0';
	 end if;
	 if(TKO_scan = '0')then
      scan_TKO <= "111";
	 else
      scan_TKO <= scan_TKO - 1;
	 end if;
	 if(scan3_sync = "01")then
	   rst_ps(7) <= '1';
	 else
	   rst_ps(7) <= '0';
	 end if;
	 rst_ps(6 downto 0) <= rst_ps(7 downto 1);
	 TKO_we <= TKO_scan and (rst_ps(7) or TKO_we);
  end if;  
end process;
process(TKO_clk)
begin
  if(TKO_clk'event and TKO_clk = '1')then
	 case scan_TKO is
	   when "000" => TKO_mux <= ps0;
	   when "001" => TKO_mux <= ps1;
	   when "010" => TKO_mux <= ps2;
	   when "011" => TKO_mux <= ps3;
	   when "100" => TKO_mux <= ps4;
	   when "101" => TKO_mux <= ps5;
	   when "110" => TKO_mux <= ps6;
	   when others => TKO_mux <= ps7;
	 end case;
  end if;  
end process;
g_TKO_buf: for i in 0 to 4 generate
  i_srl : SRL16E_1
    port map (
      Q => TKO_buf(i),       -- SRL data output
      A0 => scan(0),     -- Select[0] input
      A1 => scan(1),     -- Select[1] input
      A2 => scan(2),     -- Select[2] input
      A3 => '0',     -- Select[3] input
      CE => TKO_we,     -- Clock enable input
      CLK => TKO_clk,   -- Clock input
      D => TKO_mux(i)        -- SRL data input
   );
end generate;
process(clk)
begin
  if(clk'event and clk = '1')then
	 if(reset(8) = '1')then
	   ps8 <= "0000";
	 elsif(rst_ps(8) = '1')then
	   ps8 <= "000" & mon_in(8);
	 elsif(mon_in(8) = '1')then
		ps8 <= ps8 + 1;
	 end if;  
	 if(reset(9) = '1')then
	   ps9 <= "0000";
	 elsif(rst_ps(8) = '1')then
	   ps9 <= "000" & mon_in(9);
	 elsif(mon_in(9) = '1')then
		ps9 <= ps9 + 1;
	 end if;  
	 if(reset(10) = '1')then
	   psa <= "0000";
	 elsif(rst_ps(9) = '1')then
	   psa <= "000" & mon_in(10);
	 elsif(mon_in(10) = '1')then
		psa <= psa + 1;
	 end if;  
	 if(reset(11) = '1')then
	   psb <= "0000";
	 elsif(rst_ps(9) = '1')then
	   psb <= "000" & mon_in(11);
	 elsif(mon_in(11) = '1')then
		psb <= psb + 1;
	 end if;  
	 if(reset(12) = '1')then
	   psc <= "0000";
	 elsif(rst_ps(10) = '1')then
	   psc <= "000" & mon_in(12);
	 elsif(mon_in(12) = '1')then
		psc <= psc + 1;
	 end if;  
	 if(reset(13) = '1')then
	   psd <= "0000";
	 elsif(rst_ps(10) = '1')then
	   psd <= "000" & mon_in(13);
	 elsif(mon_in(13) = '1')then
		psd <= psd + 1;
	 end if;  
	 if(reset(14) = '1')then
	   pse <= "0000";
	 elsif(rst_ps(11) = '1')then
	   pse <= "000" & mon_in(14);
	 elsif(mon_in(14) = '1')then
		pse <= pse + 1;
	 end if;  
	 if(reset(8) = '1')then
	   psf <= "0000";
	 elsif(rst_ps(11) = '1')then
	   psf <= "000" & mon_in(15);
	 elsif(mon_in(15) = '1')then
		psf <= psf + 1;
	 end if;  
	 if(scan(4 downto 1) = x"b")then
	   scan(4 downto 1) <= x"0";
	 else
      scan(4 downto 1) <= scan(4 downto 1) + 1;	 
	 end if;
	 if(scan(4 downto 1) = x"3")then
	   rst_ps(8) <= '1';
	 else
	   rst_ps(8) <= '0';
	 end if;  
	 rst_ps(11 downto 9) <= rst_ps(10 downto 8);
  end if;  
end process;
process(clk4x)
begin
  if(clk4x'event and clk4x = '1')then
    if(clk2x = '0')then
	   scan(0) <= phase(1) or not scan(0);
	   if(scan(4) = '1')then
	     mux <= (others => '0');
	   elsif(scan(3) = '0')then
	     mux <= '0' & TKO_buf;
	   else
	     case scan(2 downto 0) is
	       when "000" => mux <= ('0' & TKO_buf) - ("00" & ps8);
	       when "001" => mux <= "00" & ps9;
	       when "010" => mux <= "00" & psa;
	       when "011" => mux <= "00" & psb;
	       when "100" => mux <= "00" & psc;
	       when "101" => mux <= "00" & psd;
	       when "110" => mux <= "00" & pse;
	       when others => mux <= "00" & psf;
	     end case;
	   end if;
	 end if;
  end if;  
end process;
g_inc: for i in 6 to 31 generate
  inc(i) <= inc(5);
end generate;
process(clk4x)
begin
  if(clk4x'event and clk4x = '1')then
	 if(clk2x = '0')then
      inc(5 downto 0) <= "000000";	 
	 else
		inc(5 downto 0) <= mux;
	 end if;
	 cntr_ra(4 downto 0) <= scan(3 downto 0) & not clk2x;
	 cntr_dout_q <= cntr_dout;
	 rst_cntr <= reset_mux;
	 if(rst_cntr = '1')then
	   cntr_din <= (others => '0');
	 else
	   cntr_din <= sum;
	 end if;
	 if(inc(31) = '1')then
	   carry <= '0';
	 else
	   carry <= co;
	 end if;
	 if(clk2x = '0')then
	   if(mux = "00000" and reset_mux = '0')then
	     cntr_we <= '0';
	   else
	     cntr_we <= '1';
	   end if;
	 end if;
	 cntr_ra_q <= cntr_ra(4 downto 0);
	 cntr_ra_q2 <= cntr_ra_q;
	 cntr_wa(4 downto 0) <= cntr_ra_q2;
  end if;  
end process;
i_adder: adder
	port map(
				a => cntr_dout_q,
				b => inc,
				ci => carry,
				s => sum,
				co => co
				);
cntr_wa(8 downto 5) <= "0000";
cntr_ra(8 downto 5) <= "0000";
i_cntr : RAMB16_S36_S36
   port map (
      DOB => cntr_dout,      -- Port B 32-bit Data Output
      ADDRA => cntr_wa,  -- Port A 9-bit Address Input
      ADDRB => cntr_ra,  -- Port B 9-bit Address Input
      CLKA => clk4x,    -- Port A Clock
      CLKB => clk4x,    -- Port B Clock
      DIA => cntr_din,      -- Port A 32-bit Data Input
      DIB => x"00000000",      -- Port B 32-bit Data Input
      DIPA => x"0",    -- Port A 4-bit parity Input
      DIPB => x"0",    -- Port-B 4-bit parity Input
      ENA => '1',      -- Port A RAM Enable Input
      ENB => '1',      -- Port B RAM Enable Input
      SSRA => '0',    -- Port A Synchronous Set/Reset Input
      SSRB => '0',    -- Port B Synchronous Set/Reset Input
      WEA => cntr_we,      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
process(clk4x)
begin
  if(clk4x'event and clk4x = '1')then
	 if(clk2x = '0')then
      update <= latch or (update and not rst_update);
		if(scan = "10111")then
		  rst_update(0) <= '1';
		else
		  rst_update(0) <= '0';
		end if;
		rst_update(15 downto 1) <= rst_update(14 downto 0);
	   if(scan(4) = '1')then
	     reset_mux <= '0';
	     update_mux <= '0';
	   else
	     case scan(3 downto 0) is
	       when x"0" => update_mux <= update(0);
							  reset_mux <= reset(0);
	       when x"1" => update_mux <= update(1);
							  reset_mux <= reset(1);
	       when x"2" => update_mux <= update(2);
							  reset_mux <= reset(2);
	       when x"3" => update_mux <= update(3);
							  reset_mux <= reset(3);
	       when x"4" => update_mux <= update(4);
							  reset_mux <= reset(4);
	       when x"5" => update_mux <= update(5);
							  reset_mux <= reset(5);
	       when x"6" => update_mux <= update(6);
							  reset_mux <= reset(6);
	       when x"7" => update_mux <= update(7);
							  reset_mux <= reset(7);
	       when x"8" => update_mux <= update(8);
							  reset_mux <= reset(8);
	       when x"9" => update_mux <= update(9);
							  reset_mux <= reset(9);
	       when x"a" => update_mux <= update(10);
							  reset_mux <= reset(10);
	       when x"b" => update_mux <= update(11);
							  reset_mux <= reset(11);
	       when x"c" => update_mux <= update(12);
							  reset_mux <= reset(12);
	       when x"d" => update_mux <= update(13);
							  reset_mux <= reset(13);
	       when x"e" => update_mux <= update(14);
							  reset_mux <= reset(14);
	       when others => update_mux <= update(15);
							  reset_mux <= reset(15);
	     end case;
	   end if;
	   latch_we <= update_mux or reset_mux;
	   buf_we <= start and not buf_we;
	 end if;
	 latch_ra(0) <= not clk2x;
	 buf_wa(0) <= clk2x;
  end if;  
end process;
i_latch : RAMB16_S36_S36
   port map (
      DOB => latch_dout,      -- Port B 32-bit Data Output
      ADDRA => cntr_wa,  -- Port A 9-bit Address Input
      ADDRB => latch_ra,  -- Port B 9-bit Address Input
      CLKA => clk4x,    -- Port A Clock
      CLKB => clk4x,    -- Port B Clock
      DIA => cntr_din,      -- Port A 32-bit Data Input
      DIB => x"00000000",      -- Port B 32-bit Data Input
      DIPA => x"0",    -- Port A 4-bit parity Input
      DIPB => x"0",    -- Port-B 4-bit parity Input
      ENA => '1',      -- Port A RAM Enable Input
      ENB => start,      -- Port B RAM Enable Input
      SSRA => '0',    -- Port A Synchronous Set/Reset Input
      SSRB => '0',    -- Port B Synchronous Set/Reset Input
      WEA => latch_we,      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
latch_ra(8 downto 1) <= "000" & addr(7 downto 3) ;
i_buf : RAMB16_S9_S36
   port map (
      DOA => dout,      -- Port A 8-bit Data Output
      ADDRA => buf_ra,  -- Port A 11-bit Address Input
      ADDRB => buf_wa,  -- Port B 9-bit Address Input
      CLKA => clk4x,    -- Port A Clock
      CLKB => clk4x,    -- Port B Clock
      DIA => x"00",      -- Port A 8-bit Data Input
      DIB => latch_dout,      -- Port B 32-bit Data Input
      DIPA => "0",    -- Port A 1-bit parity Input
      DIPB => x"0",    -- Port-B 4-bit parity Input
      ENA => '1',      -- Port A RAM Enable Input
      ENB => '1',      -- Port B RAM Enable Input
      SSRA => '0',    -- Port A Synchronous Set/Reset Input
      SSRB => '0',    -- Port B Synchronous Set/Reset Input
      WEA => '0',      -- Port A Write Enable Input
      WEB => buf_we       -- Port B Write Enable Input
   );
buf_ra <= x"00" & not addr(2 downto 0);
buf_wa(8 downto 1) <= X"00";
end Behavioral;
---------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
library UNISIM;
use UNISIM.VComponents.all;
entity adder is
  port (
    a: in std_logic_vector (31 downto 0);
    b: in std_logic_vector (31 downto 0);
    ci: in std_logic;
    s: out std_logic_vector (31 downto 0);
    co: out std_logic
  );
end adder;

architecture my_arch of adder is
signal	i,o:	std_logic_vector(31 downto 0);
signal	c:	std_logic_vector(32 downto 0);
begin
co <= c(32);
c(0) <= ci;
G1: for j in a'range generate
  i(j) <= a(j) xor b(j);
  mxcy: muxcy_d    port map (S => i(j), DI => a(j), CI => c(j), LO => c(j+1), O => o(j));
  xocy: xorcy       port map ( LI => i(j), CI => c(j), O => s(j));
end generate;
end my_arch;
