
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   15:41:01 12/18/2006
-- Design Name:   monitor
-- Module Name:   C:/iseproj/atm_dbvd/monitor_tb.vhd
-- Project Name:  atm_dbvd
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: monitor
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY monitor_tb_vhd IS
END monitor_tb_vhd;

ARCHITECTURE behavior OF monitor_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT monitor
	PORT(
		clk : IN std_logic;
		clk4x : IN std_logic;
		TKO_clk : IN std_logic;
		reset : IN std_logic_vector(15 downto 0);
		latch : IN std_logic_vector(15 downto 0);
		addr : IN std_logic_vector(15 downto 0);
		re : IN std_logic;
		we : IN std_logic;
		mon_in : IN std_logic_vector(15 downto 0);          
		ack : OUT std_logic;
		dout : OUT std_logic_vector(7 downto 0)
		);
	END COMPONENT;

	--Inputs
	SIGNAL clk :  std_logic := '0';
	SIGNAL clk4x :  std_logic := '1';
	SIGNAL TKO_clk :  std_logic := '0';
	SIGNAL reset :  std_logic_vector(15 downto 0) := (others=>'1');
	SIGNAL latch :  std_logic_vector(15 downto 0) := x"0102";
	SIGNAL re :  std_logic := '0';
	SIGNAL we :  std_logic := '0';
	SIGNAL addr :  std_logic_vector(15 downto 0) := (others=>'0');
	SIGNAL mon_in :  std_logic_vector(15 downto 0) := x"0102";

	--Outputs
	SIGNAL ack :  std_logic;
	SIGNAL dout :  std_logic_vector(7 downto 0);
signal cntr : std_logic_vector(15 downto 0) := x"0000";
BEGIN
clk <= not clk after 20ns;
clk4x <= not clk4x after 5 ns;
TKO_clk <= not TKO_clk after 8.333ns;
addr <= x"03" & cntr(7 downto 0);
process(clk)
begin
  if(clk'event and clk = '1')then
    cntr <= cntr + 1;
	 if(cntr(7 downto 4) > x"1" and cntr(3 downto 0) = x"1")then
	   re <= '1';
	 else
	   re <= '0';
	 end if;
  end if;
end process;
	-- Instantiate the Unit Under Test (UUT)
	uut: monitor PORT MAP(
		clk => clk,
		clk4x => clk4x,
		TKO_clk => TKO_clk,
		reset => reset,
		latch => latch,
		addr => addr,
		re => re,
		we => we,
		mon_in => mon_in,
		ack => ack,
		dout => dout
	);

	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 100 ns;
		reset <= x"0201";
		-- Place stimulus here

		wait; -- will wait forever
	END PROCESS;

END;
