
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   11:15:48 02/20/2008
-- Design Name:   sdram_for_ADC
-- Module Name:   C:/iseproj/atm_db3/sdram_for_adc_tb.vhd
-- Project Name:  atm_db
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: sdram_for_ADC
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY sdram_for_adc_tb_vhd IS
END sdram_for_adc_tb_vhd;

ARCHITECTURE behavior OF sdram_for_adc_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT sdram_for_ADC
	PORT(
		reset : IN std_logic;
		clk : IN std_logic;
		clk4x : IN std_logic;
		ADC_clk : IN std_logic;
		not_locked : IN std_logic;
		mem_test : IN std_logic;
		ADC_data : IN std_logic_vector(15 downto 0);
		ADC_wr : IN std_logic;
		TCP_byte_order : IN std_logic;
		TCP_ESTABLISH : IN std_logic;
		TCP_CLOSE_REQ : IN std_logic;
		TX_fifo_afull : IN std_logic;    
		mdq : INOUT std_logic_vector(15 downto 0);
		dqs : INOUT std_logic_vector(1 downto 0);      
		mem_status : OUT std_logic_vector(15 downto 0);
		fifo_afull : OUT std_logic;
		TCP_CLOSE_ACK : OUT std_logic;
		TX_fifo_data : OUT std_logic_vector(7 downto 0);
		TX_fifo_we : OUT std_logic;
		maddr : OUT std_logic_vector(12 downto 0);
		mba : OUT std_logic_vector(1 downto 0);
		dm : OUT std_logic_vector(1 downto 0);
		we_n : OUT std_logic;
		ras_n : OUT std_logic;
		cas_n : OUT std_logic;
		cs_n : OUT std_logic;
		mclke : OUT std_logic;
		mclk : OUT std_logic;
		mclk_n : OUT std_logic
		);
	END COMPONENT;
component ddr
  port(
      Clk: in std_logic;
      Clk_n: in std_logic;
      Cke: in std_logic;
      Cs_n: in std_logic;
      Ras_n: in std_logic;
      Cas_n: in std_logic;
      We_n: in std_logic;
      Ba: in std_logic_vector(1 downto 0);
      Addr: in std_logic_vector(12 downto 0);
      Dm: in std_logic_vector(1 downto 0);
      Dq: in std_logic_vector(15 downto 0);
      Dq_o: out std_logic_vector(15 downto 0);
      T_dq: out std_logic;
      Dqs: in std_logic_vector(1 downto 0);
      Dqs_o: out std_logic_vector(1 downto 0);
      T_dqs: out std_logic
  );
end component;
	--Inputs
	SIGNAL reset :  std_logic := '1';
	SIGNAL clk :  std_logic := '0';
	SIGNAL clk4x :  std_logic := '0';
	SIGNAL ADC_clk :  std_logic := '0';
	SIGNAL not_locked :  std_logic := '1';
	SIGNAL mem_test :  std_logic := '0';
	SIGNAL ADC_wr :  std_logic := '0';
	SIGNAL TCP_byte_order :  std_logic := '0';
	SIGNAL TCP_ESTABLISH :  std_logic := '1';
	SIGNAL TCP_CLOSE_REQ :  std_logic := '0';
	SIGNAL TX_fifo_afull :  std_logic := '0';
	SIGNAL ADC_data :  std_logic_vector(15 downto 0) := (others=>'0');

	--BiDirs
	SIGNAL mdq :  std_logic_vector(15 downto 0);
	SIGNAL dq_o :  std_logic_vector(15 downto 0);
	SIGNAL T_dq :  std_logic;
	SIGNAL dqs :  std_logic_vector(1 downto 0);
	SIGNAL dqs_o :  std_logic_vector(1 downto 0);
	SIGNAL T_dqs :  std_logic;

	--Outputs
	SIGNAL mem_status :  std_logic_vector(15 downto 0);
	SIGNAL fifo_afull :  std_logic;
	SIGNAL TCP_CLOSE_ACK :  std_logic;
	SIGNAL TX_fifo_data :  std_logic_vector(7 downto 0);
	SIGNAL TX_fifo_we :  std_logic;
	SIGNAL maddr :  std_logic_vector(12 downto 0);
	SIGNAL mba :  std_logic_vector(1 downto 0);
	SIGNAL dm :  std_logic_vector(1 downto 0);
	SIGNAL we_n :  std_logic;
	SIGNAL ras_n :  std_logic;
	SIGNAL cas_n :  std_logic;
	SIGNAL cs_n :  std_logic;
	SIGNAL mclke :  std_logic;
	SIGNAL mclk :  std_logic;
	SIGNAL mclk_n :  std_logic;

SIGNAL counter :  std_logic_vector(15 downto 0) := x"0000";
SIGNAL div5 :  std_logic_vector(2 downto 0) := "000";
SIGNAL div7 :  std_logic_vector(2 downto 0) := "000";
SIGNAL tx_fifo_cntr :  std_logic_vector(11 downto 0) := x"000";
SIGNAL tko_cntr :  std_logic_vector(15 downto 0) := x"0000";
SIGNAL tx_cntr :  std_logic_vector(15 downto 0) := x"0000";
SIGNAL empty_cntr :  std_logic_vector(15 downto 0) := x"0000";
SIGNAL rd_cmd :  std_logic := '0';
SIGNAL rd_mem :  std_logic := '0';
SIGNAL rd_cmd_dl :  std_logic := '0';
SIGNAL rd_data :  std_logic_vector(15 downto 0) := x"0000";
BEGIN
	mdq <= "LLLLLLLLLLLLLLLL" when T_dq = '1' else dq_o;
	dqs <= "HH" when T_dqs = '1' else dqs_o after 2ns;
i_ddr: ddr port map(
      Clk => mclk,
      Clk_n => mclk_n,
      Cke => mclke,
		Dq => mdq,
		Dq_o => dq_o,
		T_dq => T_dq,
		Addr => maddr,
		Ba => mba,
		Dm => dm,
		Dqs => dqs,
		Dqs_o => dqs_o,
		T_dqs => T_dqs,
		We_n => we_n,
		Ras_n => ras_n,
		Cas_n => cas_n,
		Cs_n => cs_n
			);
	uut: sdram_for_ADC PORT MAP(
		reset => reset,
		clk => clk,
		clk4x => clk4x,
		ADC_clk => ADC_clk,
		mem_status => mem_status,
		not_locked => not_locked,
		mem_test => mem_test,
		ADC_data => ADC_data,
		ADC_wr => ADC_wr,
		fifo_afull => fifo_afull,
		TCP_byte_order => TCP_byte_order,
		TCP_ESTABLISH => TCP_ESTABLISH,
		TCP_CLOSE_REQ => TCP_CLOSE_REQ,
		TCP_CLOSE_ACK => TCP_CLOSE_ACK,
		TX_fifo_data => TX_fifo_data,
		TX_fifo_we => TX_fifo_we,
		TX_fifo_afull => TX_fifo_afull,
		mdq => mdq,
		maddr => maddr,
		mba => mba,
		dm => dm,
		dqs => dqs,
		we_n => we_n,
		ras_n => ras_n,
		cas_n => cas_n,
		cs_n => cs_n,
		mclke => mclke,
		mclk => mclk,
		mclk_n => mclk_n
	);
	-- Instantiate the Unit Under Test (UUT)

   ADC_data <= counter;
   ADC_clk <= not ADC_clk after 25ns;
   clk4x <= not clk4x after 5ns;
	clk <= not clk after 20ns;
	process(ADC_clk)
	begin
	  if(ADC_clk'event and ADC_clk = '1')then
	    if(div7(2 downto 1) = "11" or mem_status(15) = '0')then
		   div7 <= "000";
		 else
		   div7 <= div7 + 1;
		 end if;
	    counter <= counter + 1;
		 if(div7(2 downto 1) = "11")then
		   ADC_wr <= '1';
		 else
         ADC_wr <= '0';		 
		 end if;
		 if(ADC_wr = '1')then
		   tko_cntr <= tko_cntr + 1;
		 end if;
	  end if;
	end process;
	process(clk)
	begin
	  if(clk'event and clk = '1')then
		 if(mem_status(12) = '1')then
		   empty_cntr <= empty_cntr + 1;
		 end if;
		 if(Tx_fifo_we = '1')then
		   tx_cntr <= tx_cntr + 1;
		 end if;
	    if(div5(2) = '1' or mem_status(15) = '0')then
		   div5 <= "000";
		 else
		   div5 <= div5 + 1;
		 end if;
		 tcp_establish <= mem_status(15);
		 if(tx_fifo_we /= div5(0))then
		   if(tx_fifo_we = '1')then
			  tx_fifo_cntr <= tx_fifo_cntr + 1;
			elsif(tx_fifo_cntr /= x"000")then
			  tx_fifo_cntr <= tx_fifo_cntr - 1;
			end if;
		 end if;
		 if(tx_fifo_cntr(11 downto 8) = x"0")then
		   tx_fifo_afull <= '0';
		 elsif(tx_fifo_cntr(11 downto 8) = x"f")then
		   tx_fifo_afull <= '1';
		 end if;
	  end if;
	end process;
	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 100 ns;
		not_locked <= '0';
		reset <= '0';
		-- Place stimulus here

		wait; -- will wait forever
	END PROCESS;

END;
